# pmp_muxer by jonny
# Copyright (C) 2006 jonny
#
# Homepage: http://jonny.leffe.dnsalias.com
# E-mail:   jonny@leffe.dnsalias.com
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.





package pmp_muxer;
use strict;

my $PACK = "V";

1;




sub print_d
	{
	my ($s) = @_;

	#print $s;
	}




sub Get
	{
	my ($f, $p, $len, $pv) = @_;

	(seek($f->{f}, $p, 0) == 1)          or return("seek failed on $p");
	(read($f->{f}, my $d, $len) eq $len) or return("read failed on $p");
	${$pv} = $d;

	return("ok");
	}




sub GetS
	{
	my ($f, $p, $pv) = @_;

	return(Get($f, $p, 4, $pv));
	}



sub GetS2
	{
	my ($f, $p, $pv) = @_;

	return(Get($f, $p, 2, $pv));
	}




sub GetI
	{
	my ($f, $p, $pv) = @_;

	my $d;
	my $ok = GetS($f, $p, \$d);
	($ok eq "ok") or return($ok);
	${$pv} = unpack("V", $d);

	return("ok");
	}





sub GetI2
	{
	my ($f, $p, $pv) = @_;

	my $d;
	my $ok = GetS2($f, $p, \$d);
	($ok eq "ok") or return($ok);
	${$pv} = unpack("v", $d);

	return("ok");
	}




sub idx1
	{
	my ($f, $p, $len, $s) = @_;

	while ($p != $len)
		{
		my ($ok, $v1, $v2, $v3, $v4);

		$ok = GetS($f, $p, \$v1);
		($ok eq "ok") or return($ok);
		$p += 4;

		$ok = GetI($f, $p, \$v2);
		($ok eq "ok") or return($ok);
		$p += 4;

		$ok = GetI($f, $p, \$v3);
		($ok eq "ok") or return($ok);
		$p += 4;

		$ok = GetI($f, $p, \$v4);
		($ok eq "ok") or return($ok);
		$p += 4;

		print_d($s . "[" . ($p - 16) . "-" . ($p - 1) . "] [$v1-$v2-$v3-$v4]\n");


		if ($v1 eq "00dc")
			{
			if ($v2 ne "0" && $v2 ne "16") { return("idx1: v2 ne 0 && v2 ne 16"); }

			push @{$f->{k}}, ($v2 eq "16" ? 1 : 0);
			push @{$f->{p}}, $v3;
			push @{$f->{l}}, $v4;

			print $#{$f->{k}} + 1;
			print " / $f->{dwTotalFrames}\r";
			}
		}
	print "\n";


	return("ok");
	}




sub avih
	{
	my ($f, $p, $len, $s) = @_;

	($len - $p == 56) or return("avih != 56");

	my @v =
		(
		"dwMicroSecPerFrame",
		"dwMaxBytesPerSec",
		"dwPaddingGranularity",
		"dwFlags",
		"dwTotalFrames",
		"dwInitialFrames",
		"dwStreams",
		"dwSuggestedBufferSize",
		"dwWidth",
		"dwHeight",
		"dwReserved",
		"dwReserved",
		"dwReserved",
		"dwReserved"
		);

	for (0 .. 13)
		{
		my $v;
		my $ok = GetI($f, $p, \$v);
		($ok eq "ok") or return($ok);
		$p += 4;
		print_d("$s$v[$_]=$v\n");


		if ($_ == 4) { $f->{dwTotalFrames} = $v; }
		if ($_ == 8) { $f->{dwWidth}       = $v; }
		if ($_ == 9) { $f->{dwHeight}      = $v; }
		}

	return("ok");
	}




sub strh
	{
	my ($f, $p, $len, $s) = @_;

	($len - $p == 56) or return("strh != 56");


	my @v =
		(
		"fccType",
		"fccHandler",
		"dwFlags",
		"wPriority",
		"wLanguage",
		"dwInitialFrames",
		"dwScale",
		"dwRate",
		"dwStart",
		"dwLength",
		"dwSuggestedBufferSize",
		"dwQuality",
		"dwSampleSize",
		"rcFrame.left",
		"rcFrame.top",
		"rcFrame.right",
		"rcFrame.bottom"
		);


	my @t =
		(
		"s",
		"s",
		"l",
		"i",
		"i",
		"l",
		"l",
		"l",
		"l",
		"l",
		"l",
		"l",
		"l",
		"i",
		"i",
		"i",
		"i"
		);


	for (0 .. 16)
		{
		my $v;
		my $ok;

		if ($t[$_] eq "s")
			{
			$ok = GetS($f, $p, \$v);
			$p += 4;
			}
		elsif ($t[$_] eq "l")
			{
			$ok = GetI($f, $p, \$v);
			$p += 4;
			}
		elsif ($t[$_] eq "i")
			{
			$ok = GetI2($f, $p, \$v);
			$p += 2;
			}

		($ok eq "ok") or return($ok);
		print_d("$s$v[$_]=$v\n");


		if ($_ == 0 && $v eq "auds")
			{
			last;
			}


		if ($_ == 6) { $f->{dwScale} = $v; }
		if ($_ == 7) { $f->{dwRate}  = $v; }
		}



	return("ok");
	}






sub Parse
	{
	my ($f, $p, $len, $s, $movi, $idx1) = @_;

	while ($p != $len)
		{
		my ($ok, $v1, $v2, $v3);

		$ok = GetS($f, $p, \$v1);
		($ok eq "ok") or return($ok);
		$p += 4;

		$ok = GetI($f, $p, \$v2);
		($ok eq "ok") or return($ok);
		$p += 4;

		my $v2s = $v2 % 2 ? "$v2+1" : "$v2";
		$v2     = $v2 % 2 ? $v2 + 1 : $v2;

		if ($v1 eq "RIFF" || $v1 eq "LIST")
			{
			$ok = GetS($f, $p, \$v3);
			($ok eq "ok") or return($ok);
			print_d($s . "[" . ($p - 8) . "-" . ($p + 3) . "] [$v1-$v2s-$v3] ");
			print_d("[" . ($p + 4) . "-" . ($p + $v2 - 1) . "]\n");

			my $view = 1;

			if (!$movi && $v3 eq "movi")
				{
				$view = 0;
				}


			if ($v3 eq "movi")
				{
				$f->{movi} = $p - 8 + 16;
				}


			if ($view)
				{
				$ok = Parse($f, $p + 4, $p + $v2, "$s  ", $movi, $idx1);
				($ok eq "ok") or return($ok);
				}
			}
		else
			{
			print_d($s . "[" . ($p - 8) . "-" . ($p - 1) . "] [$v1-$v2s] ");
			print_d("[$p-" . ($p + $v2 - 1) . "]\n");

			if ($v1 eq "idx1" && $idx1)
				{
				$ok = idx1($f, $p, $p + $v2, "$s  ");
				($ok eq "ok") or return($ok);
				}


			if ($v1 eq "avih")
				{
				$ok = avih($f, $p, $p + $v2, "$s  ");
				($ok eq "ok") or return($ok);
				}


			if ($v1 eq "strh")
				{
				$ok = strh($f, $p, $p + $v2, "$s  ");
				($ok eq "ok") or return($ok);
				}
			}

		$p += $v2;
		}

	return("ok");
	}



sub AviParse
	{
	my ($s, $movi, $idx1) = @_;

	open(my $f, $s) or return("open failed on \"$s\"");
	binmode($f)     or return("binmode failed on \"$s\"");

	my @v = stat($f);
	@v              or return("stat failed on \"$s\"");

	my %f = ("f", $f, "k", [], "l", [], "p", []);

	my $ok = Parse(\%f, 0, $v[7], "", $movi, $idx1);

	#close($f)       or return("close failed on \"$s\"");

	return($ok, \%f);
	}



sub make_video
	{
	my ($s, $out) = @_;



	print "Processing video ...\n";



	my ($ok, $f) = AviParse($s, 0, 1);
	($ok eq "ok") or return($ok);




	print("dwTotalFrames: $f->{dwTotalFrames}\n");
	print("dwWidth:       $f->{dwWidth}\n");
	print("dwHeight:      $f->{dwHeight}\n");
	print("dwScale:       $f->{dwScale}\n");
	print("dwRate:        $f->{dwRate}\n");
	print("movi:          $f->{movi}\n");



	($f->{dwTotalFrames} == $#{$f->{k}} + 1) or return("invalid dwTotalFrames");


	my $Max = 0;
	for (0 .. $#{$f->{k}})
		{
		#print $f->{k}->[$_];
		#print " " . $f->{p}->[$_];
		#print " " . $f->{l}->[$_];
		#print "\n";


		if ($f->{l}->[$_] > $Max)
			{
            $Max = $f->{l}->[$_];
			}
		}
	print("Max:           $Max\n");








	open(my $fout, ">$out") or return("open failed on \"$out\"");
	binmode($fout)          or return("binmode failed on \"$out\"");



	print $fout "pmpm";
	print $fout pack($PACK, 0);

	print $fout pack($PACK, $f->{dwTotalFrames});
	print $fout pack($PACK, $f->{dwWidth});
	print $fout pack($PACK, $f->{dwHeight});
	print $fout pack($PACK, $f->{dwScale});
	print $fout pack($PACK, $f->{dwRate});
	print $fout pack($PACK, $Max);



	for (0 .. $#{$f->{k}})
		{
		print $fout pack($PACK, ($f->{l}->[$_] << 1) + $f->{k}->[$_]);
		}



	for (0 .. $#{$f->{k}})
		{
		my $d;
		my $ok = Get($f, $f->{movi} + $f->{p}->[$_], $f->{l}->[$_], \$d);
		($ok eq "ok") or return($ok);
		print(($_ + 1) . " / $f->{dwTotalFrames}\r");


		print $fout $d;
		}
	print "\n";



	close($fout)            or return("close failed on \"$out\"");




	return("ok");
	}
	
	
	
	
	
	
sub add_mp3
	{
	my ($in, $out) = @_;



	print "Processing audio ...\n";



	my %b =
		(
		"0001", 104,
		"0010", 130,
		"0011", 156,
		"0100", 182,
		"0101", 208,
		"0110", 261,
		"0111", 313,
		"1000", 365,
		"1001", 417,
		"1010", 522,
		"1011", 626,
		"1100", 731,
		"1101", 835,
		"1110", 1044,
		);


	open(my $f, $in) or return("open failed on \"$in\"");
	binmode($f)      or return("binmode failed on \"$in\"");


	my $last_b = "";




	my @l = ();
	while (1)
		{
		my $l = read($f, my $d, 4);
		($l != 0) or last;
		($l eq "4") or return("bad eof");


		my $TAG = substr($d, 0, 3);
		($TAG ne "TAG") or last;


		$d = sprintf("%032b", unpack("N", $d));


		my $s = substr($d, 0, 11, "");
		($s eq "11111111111") or return("sync lost");


		$s = substr($d, 0, 2, "");
		($s eq "11") or return("MPEG Version != 1");


		$s = substr($d, 0, 2, "");
		($s eq "01") or return("Layer != III");


		$s = substr($d, 0, 1, "");
		$s = substr($d, 0, 4, "");
		(defined($b{$s})) or return("invalid bitrate");


		if ($last_b eq "")
			{
			$last_b = $b{$s};
			}
		else
			{
			($last_b eq $b{$s}) or return("vbr not supported");
			}



		$s = substr($d, 0, 2, "");
		($s eq "00") or return("Sampling rate frequency != 44100");


		push @l, substr($d, 0, 1, "");
		
		
		(read($f, $d, $last_b + $l[$#l] - 4) eq ($last_b + $l[$#l] - 4)) or return("read error");
		print(($#l + 1) . "\r");
		}
	print("\n");



	(seek($f, 0, 0) == 1) or return("seek failed");






	open(my $fout, ">>$out") or return("open failed on \"$out\"");
	binmode($fout)           or return("binmode failed on \"$out\"");





	print $fout pack($PACK, $last_b);
	print $fout pack($PACK, ($#l + 1));
	for (0 .. $#l)
		{
		print $fout pack("C", $l[$_]);
		}




	for (0 .. $#l)
		{
		(read($f, my $d, $last_b + $l[$_]) eq ($last_b + $l[$_])) or return("read error");
		print(($_ + 1) . "\r");


		print $fout $d;
		}
	print("\n");





	close($fout)            or return("close failed on \"$out\"");


	close($f)        or return("close failed on \"$in\"");


	return("ok");
	}




sub mux
	{
	my ($v_in, $a_in, $out) = @_;
	
	
	
	my $ok = make_video($v_in, $out);
	($ok eq "ok") or return($ok);


	$ok = add_mp3($a_in, $out);
	($ok eq "ok") or return($ok);



	return("ok");
	}
